// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.measure;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2013 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */


/**
 * <p>
 * Résultat de mesure de quantification d'un lot ou d'un produit.
 * </p>
 * <p>
 * Les mesures de quantification portent sur le paramètre "Poids".
 * Elle peuvent être obtenue par différentes méthodes :
 * </p>
 * <p>
 * - mesuré (ex : par une règle ou Ichtyomètre),
 * </p>
 * <p>
 * - estimé (ex : jugement par un expert),
 * </p>
 * <p>
 * - calculé par une relation taille/poids
 * </p>
 * <p>
 * - calculé à partir de volumes (nombre d'unité de volume x Poids
 * d'une unité de volume). Il s'agit donc d'un poids estimé, mais
 * par le volume.
 * </p>
 * <p>
 * - déclaré (cf SACROIS/RIC2)
 * </p>
 */
public abstract class QuantificationMeasurement
    extends fr.ifremer.adagio.core.dao.data.measure.MeasurementImpl
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -9133401313776729152L;

    private java.lang.Short subgroupNumber;

    /**
     * <p>
     * Numéro du sous ensemble sur lequel porte la mesure de
     * quantification. Si non renseigné, le mesure porte sur tout le
     * lot rattaché.Une quantification d'un lot peut faire intervenir
     * plusieurs sous-ensemble sur lequel des mesures sont éffectuées.
     * Par exemple, plusieurs sous-ensembles peuvent être quantifié par
     * pesée, chaque mesure est donc rattaché à un sous-ensemmble, via
     * le numéro de sous ensemble.
     * </p>
     */
    public java.lang.Short getSubgroupNumber()
    {
        return this.subgroupNumber;
    }

    public void setSubgroupNumber(java.lang.Short subgroupNumber)
    {
        this.subgroupNumber = subgroupNumber;
    }

    private java.lang.Boolean isReferenceQuantification;

    /**
     * <p>
     * S'agit t il de la mesure de référence pour la quantification du
     * lot ? Par défaut, le poids calculé (par relation taille/poids)
     * est le poids de référence.
     * </p>
     * <p>
     * Doit etre NULL si subgroupNumber est NULL (un poids de référence
     * ne peut pas porter sur une sous-ensemble du lot , mais sur tout
     * le lot)
     * </p>
     */
    public java.lang.Boolean getIsReferenceQuantification()
    {
        return this.isReferenceQuantification;
    }

    public void setIsReferenceQuantification(java.lang.Boolean isReferenceQuantification)
    {
        this.isReferenceQuantification = isReferenceQuantification;
    }


    private fr.ifremer.adagio.core.dao.data.batch.Batch batch;

    /**
     * <p>
     * Lot auquel est rattaché la mesure de quantification (optionnel).
     * </p>
     */
    public fr.ifremer.adagio.core.dao.data.batch.Batch getBatch()
    {
        return this.batch;
    }

    public void setBatch(fr.ifremer.adagio.core.dao.data.batch.Batch batch)
    {
        this.batch = batch;
    }

    /**
     * This entity does not have any identifiers
     * but since it extends the <code>fr.ifremer.adagio.core.dao.data.measure.MeasurementImpl</code> class
     * it will simply delegate the call up there.
     *
     * @see fr.ifremer.adagio.core.dao.data.measure.Measurement#equals(Object)
     */
    public boolean equals(Object object)
    {
        return super.equals(object);
    }

    /**
     * This entity does not have any identifiers
     * but since it extends the <code>fr.ifremer.adagio.core.dao.data.measure.MeasurementImpl</code> class
     * it will simply delegate the call up there.
     *
     * @see fr.ifremer.adagio.core.dao.data.measure.Measurement#hashCode()
     */
    public int hashCode()
    {
        return super.hashCode();
    }

    /**
     * Constructs new instances of {@link fr.ifremer.adagio.core.dao.data.measure.QuantificationMeasurement}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.measure.QuantificationMeasurement}.
         */
        public static fr.ifremer.adagio.core.dao.data.measure.QuantificationMeasurement newInstance()
        {
            final fr.ifremer.adagio.core.dao.data.measure.QuantificationMeasurement entity = new fr.ifremer.adagio.core.dao.data.measure.QuantificationMeasurementImpl();
			return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.measure.QuantificationMeasurement}, taking all required and/or
         * read-only properties as arguments.
         */
        public static fr.ifremer.adagio.core.dao.data.measure.QuantificationMeasurement newInstance(fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag, fr.ifremer.adagio.core.dao.referential.pmfm.Pmfm pmfm, fr.ifremer.adagio.core.dao.data.batch.Batch batch)
        {
            final fr.ifremer.adagio.core.dao.data.measure.QuantificationMeasurement entity = newInstance();
            entity.setQualityFlag(qualityFlag);
            entity.setPmfm(pmfm);
            entity.setBatch(batch);
            return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.measure.QuantificationMeasurement}, taking all possible properties
         * (except the identifier(s))as arguments.
         */
        public static fr.ifremer.adagio.core.dao.data.measure.QuantificationMeasurement newInstance(java.lang.Float numericalValue, java.lang.String alphanumericalValue, java.lang.Integer digitCount, java.lang.Float precisionValue, java.util.Date controlDate, java.util.Date validationDate, java.util.Date qualificationDate, java.lang.String qualificationComments, fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag, fr.ifremer.adagio.core.dao.referential.pmfm.AggregationLevel aggregationLevel, fr.ifremer.adagio.core.dao.referential.PrecisionType precisionType, fr.ifremer.adagio.core.dao.referential.AnalysisInstrument analysisInstrument, fr.ifremer.adagio.core.dao.referential.NumericalPrecision numericalPrecision, fr.ifremer.adagio.core.dao.administration.user.Department department, fr.ifremer.adagio.core.dao.referential.pmfm.Pmfm pmfm, fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue qualitativeValue, java.lang.Short subgroupNumber, java.lang.Boolean isReferenceQuantification, fr.ifremer.adagio.core.dao.data.batch.Batch batch)
        {
            final fr.ifremer.adagio.core.dao.data.measure.QuantificationMeasurement entity = newInstance();
            entity.setNumericalValue(numericalValue);
            entity.setAlphanumericalValue(alphanumericalValue);
            entity.setDigitCount(digitCount);
            entity.setPrecisionValue(precisionValue);
            entity.setControlDate(controlDate);
            entity.setValidationDate(validationDate);
            entity.setQualificationDate(qualificationDate);
            entity.setQualificationComments(qualificationComments);
            entity.setQualityFlag(qualityFlag);
            entity.setAggregationLevel(aggregationLevel);
            entity.setPrecisionType(precisionType);
            entity.setAnalysisInstrument(analysisInstrument);
            entity.setNumericalPrecision(numericalPrecision);
            entity.setDepartment(department);
            entity.setPmfm(pmfm);
            entity.setQualitativeValue(qualitativeValue);
            entity.setSubgroupNumber(subgroupNumber);
            entity.setIsReferenceQuantification(isReferenceQuantification);
            entity.setBatch(batch);
            return entity;
        }
    }
    
// QuantificationMeasurement.java merge-point
}