// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.survey.declaration;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2013 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */


/**
 * <p>
 * Référence du document déclaratif. Utile pour les données issu du
 * log book électronique (flux SACAPT.)
 * </p>
 */
public abstract class DeclaredDocumentReference
    implements java.io.Serializable
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -2075697851289447656L;

    private java.lang.Integer id;

    /**
     * <p>
     * Identifiant interne de la référence de document déclaratif.
     * Généré par le système.
     * </p>
     */
    public java.lang.Integer getId()
    {
        return this.id;
    }

    public void setId(java.lang.Integer id)
    {
        this.id = id;
    }

    private java.lang.String synchronizationStatus;

    /**
     * <p>
     * Etat de synchronisation (en cours, terminé, en attente de
     * synchro, supprimé). Seulement visible dans la base locale.
     * </p>
     */
    public java.lang.String getSynchronizationStatus()
    {
        return this.synchronizationStatus;
    }

    public void setSynchronizationStatus(java.lang.String synchronizationStatus)
    {
        this.synchronizationStatus = synchronizationStatus;
    }

    private java.lang.String reference;

    /**
     * <p>
     * Numéro de la fiche de peche.
     * </p>
     * <p>
     * issu du flux SACAPT.
     * </p>
     * <p>
     * Cela sert à regrouper les marées par fiche de peche.
     * </p>
     */
    public java.lang.String getReference()
    {
        return this.reference;
    }

    public void setReference(java.lang.String reference)
    {
        this.reference = reference;
    }

    private java.lang.String fileName;

    /**
     * <p>
     * Nom du fichier ayant servi à importer les données déclarées dans
     * la base.
     * </p>
     * <p>
     * ex : Nom du fichier d'origine de la vente = BL_070212_1215.ric
     * </p>
     */
    public java.lang.String getFileName()
    {
        return this.fileName;
    }

    public void setFileName(java.lang.String fileName)
    {
        this.fileName = fileName;
    }

    private java.util.Date documentDate;

    /**
     * 
     */
    public java.util.Date getDocumentDate()
    {
        return this.documentDate;
    }

    public void setDocumentDate(java.util.Date documentDate)
    {
        this.documentDate = documentDate;
    }

    private java.lang.String otherDocumentReference;

    /**
     * <p>
     * Autre référence sur le document déclaratif.
     * </p>
     * <p>
     * Utilisé dans SACROIS/RIC2 : Ce code permet de transmettre dans
     * le fichier RIC2 l’information renseignée sur la note de vente
     * dans la case « Document joint à la note de vente (le cas
     * échéant) » :
     * </p>
     * <p>
     * T2M/Déclaration de débarquement, document de transport,
     * déclaration de prise en
     * </p>
     * <p>
     * charge. Ce code permet de préciser, lorsqu’aucun document n’est
     * joint à la note de vente, si ce défaut de document joint est ou
     * non une anomalie du point de vue de la
     * </p>
     * <p>
     * réglementation.
     * </p>
     * <p>
     * Exemple :
     * </p>
     * <p>
     * - 0 : aucun document joint à la note de vente – sans objet
     * </p>
     * <p>
     * - 1 : aucun document joint à la note de vente – anomalie
     * réglementaire
     * </p>
     * <p>
     * - 2 : T2M / déclaration de débarquement
     * </p>
     * <p>
     * - 3 : Document de transport
     * </p>
     * <p>
     * - 4 : Déclaration de prise en charge
     * </p>
     */
    public java.lang.String getOtherDocumentReference()
    {
        return this.otherDocumentReference;
    }

    public void setOtherDocumentReference(java.lang.String otherDocumentReference)
    {
        this.otherDocumentReference = otherDocumentReference;
    }

    private java.lang.String firstSheetNumber;

    /**
     * <p>
     * Numéro du premier feuillet de la déclaration. Utilisé dans
     * SACROIS/SIPA.
     * </p>
     * <p>
     * Il peut s'agir d'un code alphanumérique (référence du feuillet).
     * </p>
     */
    public java.lang.String getFirstSheetNumber()
    {
        return this.firstSheetNumber;
    }

    public void setFirstSheetNumber(java.lang.String firstSheetNumber)
    {
        this.firstSheetNumber = firstSheetNumber;
    }

    private java.lang.String lastSheetNumber;

    /**
     * <p>
     * Numéro du dernier feuillet de la déclaration. Utilisé dans
     * SACROIS/SIPA.
     * </p>
     * <p>
     * Il peut s'agir d'un code alphanumérique (référence du feuillet).
     * </p>
     */
    public java.lang.String getLastSheetNumber()
    {
        return this.lastSheetNumber;
    }

    public void setLastSheetNumber(java.lang.String lastSheetNumber)
    {
        this.lastSheetNumber = lastSheetNumber;
    }

    private java.lang.Short sheetCount;

    /**
     * <p>
     * Nombre de feuillets dans la déclaration. Utilisé dans
     * SACROIS/SIPA
     * </p>
     */
    public java.lang.Short getSheetCount()
    {
        return this.sheetCount;
    }

    public void setSheetCount(java.lang.Short sheetCount)
    {
        this.sheetCount = sheetCount;
    }

    private java.lang.String comments;

    /**
     * <p>
     * Commentaire.
     * </p>
     */
    public java.lang.String getComments()
    {
        return this.comments;
    }

    public void setComments(java.lang.String comments)
    {
        this.comments = comments;
    }

    private java.util.Date creationDate;

    /**
     * <p>
     * Date de création de l'enquete dans le système central.
     * </p>
     */
    public java.util.Date getCreationDate()
    {
        return this.creationDate;
    }

    public void setCreationDate(java.util.Date creationDate)
    {
        this.creationDate = creationDate;
    }

    private java.util.Date controlDate;

    /**
     * 
     */
    public java.util.Date getControlDate()
    {
        return this.controlDate;
    }

    public void setControlDate(java.util.Date controlDate)
    {
        this.controlDate = controlDate;
    }

    private java.util.Date validationDate;

    /**
     * 
     */
    public java.util.Date getValidationDate()
    {
        return this.validationDate;
    }

    public void setValidationDate(java.util.Date validationDate)
    {
        this.validationDate = validationDate;
    }

    private java.util.Date qualificationDate;

    /**
     * 
     */
    public java.util.Date getQualificationDate()
    {
        return this.qualificationDate;
    }

    public void setQualificationDate(java.util.Date qualificationDate)
    {
        this.qualificationDate = qualificationDate;
    }

    private java.lang.String qualificationComments;

    /**
     * 
     */
    public java.lang.String getQualificationComments()
    {
        return this.qualificationComments;
    }

    public void setQualificationComments(java.lang.String qualificationComments)
    {
        this.qualificationComments = qualificationComments;
    }

    private java.sql.Timestamp updateDate;

    /**
     * 
     */
    public java.sql.Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    public void setUpdateDate(java.sql.Timestamp updateDate)
    {
        this.updateDate = updateDate;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip> fishingTrips = new java.util.HashSet<fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip> getFishingTrips()
    {
        return this.fishingTrips;
    }

    public void setFishingTrips(java.util.Collection<fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip> fishingTrips)
    {
        this.fishingTrips = fishingTrips;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.data.survey.sale.Sale> sales = new java.util.HashSet<fr.ifremer.adagio.core.dao.data.survey.sale.Sale>();

    /**
     * <p>
     * Ventes déclarées
     * </p>
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.data.survey.sale.Sale> getSales()
    {
        return this.sales;
    }

    public void setSales(java.util.Collection<fr.ifremer.adagio.core.dao.data.survey.sale.Sale> sales)
    {
        this.sales = sales;
    }


    private fr.ifremer.adagio.core.dao.administration.programStrategy.Program program;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.administration.programStrategy.Program getProgram()
    {
        return this.program;
    }

    public void setProgram(fr.ifremer.adagio.core.dao.administration.programStrategy.Program program)
    {
        this.program = program;
    }


    private fr.ifremer.adagio.core.dao.administration.user.Person recorderPerson;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.administration.user.Person getRecorderPerson()
    {
        return this.recorderPerson;
    }

    public void setRecorderPerson(fr.ifremer.adagio.core.dao.administration.user.Person recorderPerson)
    {
        this.recorderPerson = recorderPerson;
    }


    private fr.ifremer.adagio.core.dao.data.vessel.Vessel vessel;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.data.vessel.Vessel getVessel()
    {
        return this.vessel;
    }

    public void setVessel(fr.ifremer.adagio.core.dao.data.vessel.Vessel vessel)
    {
        this.vessel = vessel;
    }


    private fr.ifremer.adagio.core.dao.administration.user.Department recorderDepartment;

    /**
     * <p>
     * Service saisisseur
     * </p>
     */
    public fr.ifremer.adagio.core.dao.administration.user.Department getRecorderDepartment()
    {
        return this.recorderDepartment;
    }

    public void setRecorderDepartment(fr.ifremer.adagio.core.dao.administration.user.Department recorderDepartment)
    {
        this.recorderDepartment = recorderDepartment;
    }


    private fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag;

    /**
     * <p>
     * Niveau de qualité de la donnée.
     * </p>
     * <p>
     * "Non qualifiée" par défaut
     * </p>
     */
    public fr.ifremer.adagio.core.dao.referential.QualityFlag getQualityFlag()
    {
        return this.qualityFlag;
    }

    public void setQualityFlag(fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag)
    {
        this.qualityFlag = qualityFlag;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference> childDeclaredDocumentReferences = new java.util.HashSet<fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference> getChildDeclaredDocumentReferences()
    {
        return this.childDeclaredDocumentReferences;
    }

    public void setChildDeclaredDocumentReferences(java.util.Collection<fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference> childDeclaredDocumentReferences)
    {
        this.childDeclaredDocumentReferences = childDeclaredDocumentReferences;
    }


    private fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference parentDeclaredDocumentReference;

    /**
     * <p>
     * Référence du document déclaratif parent.
     * </p>
     * <p>
     * Utile dans SACAPT.
     * </p>
     * <p>
     * Cela sert à regrouper les marées par fiche de peche.
     * </p>
     */
    public fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference getParentDeclaredDocumentReference()
    {
        return this.parentDeclaredDocumentReference;
    }

    public void setParentDeclaredDocumentReference(fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference parentDeclaredDocumentReference)
    {
        this.parentDeclaredDocumentReference = parentDeclaredDocumentReference;
    }



    private java.util.Collection<fr.ifremer.adagio.core.dao.data.measure.SurveyMeasurement> surveyMeasurements = new java.util.HashSet<fr.ifremer.adagio.core.dao.data.measure.SurveyMeasurement>();

    /**
     * <p>
     * Caractéristiques additionnelles du document déclaratif.
     * </p>
     * <p>
     * Par exemple : Type de document (PSFM+valeurs qualitatives), etc.
     * </p>
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.data.measure.SurveyMeasurement> getSurveyMeasurements()
    {
        return this.surveyMeasurements;
    }

    public void setSurveyMeasurements(java.util.Collection<fr.ifremer.adagio.core.dao.data.measure.SurveyMeasurement> surveyMeasurements)
    {
        this.surveyMeasurements = surveyMeasurements;
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof DeclaredDocumentReference))
        {
            return false;
        }
        final DeclaredDocumentReference that = (DeclaredDocumentReference)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (id == null ? 0 : id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference}.
         */
        public static fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference newInstance()
        {
            final fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference entity = new fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReferenceImpl();
			return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference}, taking all required and/or
         * read-only properties as arguments.
         */
        public static fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference newInstance(java.lang.String synchronizationStatus, java.util.Date documentDate, java.util.Date creationDate, fr.ifremer.adagio.core.dao.administration.programStrategy.Program program, fr.ifremer.adagio.core.dao.data.vessel.Vessel vessel, fr.ifremer.adagio.core.dao.administration.user.Department recorderDepartment, fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag)
        {
            final fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference entity = newInstance();
            entity.setSynchronizationStatus(synchronizationStatus);
            entity.setDocumentDate(documentDate);
            entity.setCreationDate(creationDate);
            entity.setProgram(program);
            entity.setVessel(vessel);
            entity.setRecorderDepartment(recorderDepartment);
            entity.setQualityFlag(qualityFlag);
            return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference}, taking all possible properties
         * (except the identifier(s))as arguments.
         */
        public static fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference newInstance(java.lang.String synchronizationStatus, java.lang.String reference, java.lang.String fileName, java.util.Date documentDate, java.lang.String otherDocumentReference, java.lang.String firstSheetNumber, java.lang.String lastSheetNumber, java.lang.Short sheetCount, java.lang.String comments, java.util.Date creationDate, java.util.Date controlDate, java.util.Date validationDate, java.util.Date qualificationDate, java.lang.String qualificationComments, java.sql.Timestamp updateDate, java.util.Collection<fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip> fishingTrips, java.util.Collection<fr.ifremer.adagio.core.dao.data.survey.sale.Sale> sales, fr.ifremer.adagio.core.dao.administration.programStrategy.Program program, fr.ifremer.adagio.core.dao.administration.user.Person recorderPerson, fr.ifremer.adagio.core.dao.data.vessel.Vessel vessel, fr.ifremer.adagio.core.dao.administration.user.Department recorderDepartment, fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag, java.util.Collection<fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference> childDeclaredDocumentReferences, fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference parentDeclaredDocumentReference, java.util.Collection<fr.ifremer.adagio.core.dao.data.measure.SurveyMeasurement> surveyMeasurements)
        {
            final fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference entity = newInstance();
            entity.setSynchronizationStatus(synchronizationStatus);
            entity.setReference(reference);
            entity.setFileName(fileName);
            entity.setDocumentDate(documentDate);
            entity.setOtherDocumentReference(otherDocumentReference);
            entity.setFirstSheetNumber(firstSheetNumber);
            entity.setLastSheetNumber(lastSheetNumber);
            entity.setSheetCount(sheetCount);
            entity.setComments(comments);
            entity.setCreationDate(creationDate);
            entity.setControlDate(controlDate);
            entity.setValidationDate(validationDate);
            entity.setQualificationDate(qualificationDate);
            entity.setQualificationComments(qualificationComments);
            entity.setUpdateDate(updateDate);
            entity.setFishingTrips(fishingTrips);
            entity.setSales(sales);
            entity.setProgram(program);
            entity.setRecorderPerson(recorderPerson);
            entity.setVessel(vessel);
            entity.setRecorderDepartment(recorderDepartment);
            entity.setQualityFlag(qualityFlag);
            entity.setChildDeclaredDocumentReferences(childDeclaredDocumentReferences);
            entity.setParentDeclaredDocumentReference(parentDeclaredDocumentReference);
            entity.setSurveyMeasurements(surveyMeasurements);
            return entity;
        }
    }
    
// DeclaredDocumentReference.java merge-point
}