// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.operation.denormalized;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2013 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */


/**
 * <p>
 * ATTENTION : Table technique. (RAZ des données possible) Ne pas
 * remplir directement, mais passer par OPERATION.
 * </p>
 * <p>
 * Opération sous forme dénormalisée (mise en colonne des mesures,
 * etc).
 * </p>
 * <p>
 * L'intéret est l'optimisation des routine d'extraction (ex :
 * extraction COST), d'exploitation des données (reporting BIRT),
 * etc.
 * </p>
 */
public abstract class DenormalizedOperation
    implements java.io.Serializable
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 5302340262291034958L;

    private java.lang.Long id;

    /**
     * <p>
     * Identifiant de l'opération.
     * </p>
     * <p>
     * Doit etre identique à celui de la table OPERATION : pas de
     * numérotation automatique.
     * </p>
     */
    public java.lang.Long getId()
    {
        return this.id;
    }

    public void setId(java.lang.Long id)
    {
        this.id = id;
    }

    private java.lang.Short rankOrder;

    /**
     * <p>
     * Numéro d'ordre de l'opération dans la marée.
     * </p>
     * <p>
     * L'ordre est déterminée par un tri par odre croissant des dates
     * de fin d'opération.
     * </p>
     */
    public java.lang.Short getRankOrder()
    {
        return this.rankOrder;
    }

    public void setRankOrder(java.lang.Short rankOrder)
    {
        this.rankOrder = rankOrder;
    }

    private java.lang.Boolean isLandingSampling;

    /**
     * <p>
     * La partie retenue a t'elle été échantillonnée comme le prévoit
     * le protocole ?
     * </p>
     * <p>
     * (cf manuel de l'observateur du programme de collecte concerné)
     * </p>
     */
    public java.lang.Boolean getIsLandingSampling()
    {
        return this.isLandingSampling;
    }

    public void setIsLandingSampling(java.lang.Boolean isLandingSampling)
    {
        this.isLandingSampling = isLandingSampling;
    }

    private java.lang.Boolean isDiscardSampling;

    /**
     * <p>
     * La partie non retenue a t'elle été échantillonnée comme le
     * prévoit le protocole ?
     * </p>
     * <p>
     * (cf manuel de l'observateur du programme de collecte concerné)
     * </p>
     */
    public java.lang.Boolean getIsDiscardSampling()
    {
        return this.isDiscardSampling;
    }

    public void setIsDiscardSampling(java.lang.Boolean isDiscardSampling)
    {
        this.isDiscardSampling = isDiscardSampling;
    }

    private java.lang.Float gearMeshSize;

    /**
     * <p>
     * Maillage étiré de l'engin (en millimètre)
     * </p>
     */
    public java.lang.Float getGearMeshSize()
    {
        return this.gearMeshSize;
    }

    public void setGearMeshSize(java.lang.Float gearMeshSize)
    {
        this.gearMeshSize = gearMeshSize;
    }

    private java.lang.Float gearDepth;

    /**
     * <p>
     * Profondeur moyenne de l'engin (en mètre).
     * </p>
     * <p>
     * ref : COST
     * </p>
     */
    public java.lang.Float getGearDepth()
    {
        return this.gearDepth;
    }

    public void setGearDepth(java.lang.Float gearDepth)
    {
        this.gearDepth = gearDepth;
    }

    private java.lang.Float mainWaterDepth;

    /**
     * <p>
     * Hauteur d'eau moyenne (en mètre)?
     * </p>
     * <p>
     * ref : COST ?
     * </p>
     */
    public java.lang.Float getMainWaterDepth()
    {
        return this.mainWaterDepth;
    }

    public void setMainWaterDepth(java.lang.Float mainWaterDepth)
    {
        this.mainWaterDepth = mainWaterDepth;
    }

    private java.sql.Timestamp updateDate;

    /**
     * 
     */
    public java.sql.Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    public void setUpdateDate(java.sql.Timestamp updateDate)
    {
        this.updateDate = updateDate;
    }


    private fr.ifremer.adagio.core.dao.referential.location.Location subpolygonLocation;

    /**
     * <p>
     * Sous-polygone (cf spécifications COST)
     * </p>
     */
    public fr.ifremer.adagio.core.dao.referential.location.Location getSubpolygonLocation()
    {
        return this.subpolygonLocation;
    }

    public void setSubpolygonLocation(fr.ifremer.adagio.core.dao.referential.location.Location subpolygonLocation)
    {
        this.subpolygonLocation = subpolygonLocation;
    }


    private fr.ifremer.adagio.core.dao.referential.location.Location rectangleLocation;

    /**
     * <p>
     * Rectangle statistique
     * </p>
     */
    public fr.ifremer.adagio.core.dao.referential.location.Location getRectangleLocation()
    {
        return this.rectangleLocation;
    }

    public void setRectangleLocation(fr.ifremer.adagio.core.dao.referential.location.Location rectangleLocation)
    {
        this.rectangleLocation = rectangleLocation;
    }


    private fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue selectiveDevice;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue getSelectiveDevice()
    {
        return this.selectiveDevice;
    }

    public void setSelectiveDevice(fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue selectiveDevice)
    {
        this.selectiveDevice = selectiveDevice;
    }


    private fr.ifremer.adagio.core.dao.referential.gear.Gear gear;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.referential.gear.Gear getGear()
    {
        return this.gear;
    }

    public void setGear(fr.ifremer.adagio.core.dao.referential.gear.Gear gear)
    {
        this.gear = gear;
    }


    private fr.ifremer.adagio.core.dao.referential.location.Location areaLocation;

    /**
     * <p>
     * Area (cf spécifications COST)
     * </p>
     */
    public fr.ifremer.adagio.core.dao.referential.location.Location getAreaLocation()
    {
        return this.areaLocation;
    }

    public void setAreaLocation(fr.ifremer.adagio.core.dao.referential.location.Location areaLocation)
    {
        this.areaLocation = areaLocation;
    }


    private fr.ifremer.adagio.core.dao.referential.metier.Metier metier;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.referential.metier.Metier getMetier()
    {
        return this.metier;
    }

    public void setMetier(fr.ifremer.adagio.core.dao.referential.metier.Metier metier)
    {
        this.metier = metier;
    }


    private fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip fishingTrip;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip getFishingTrip()
    {
        return this.fishingTrip;
    }

    public void setFishingTrip(fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip fishingTrip)
    {
        this.fishingTrip = fishingTrip;
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof DenormalizedOperation))
        {
            return false;
        }
        final DenormalizedOperation that = (DenormalizedOperation)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (id == null ? 0 : id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link fr.ifremer.adagio.core.dao.data.operation.denormalized.DenormalizedOperation}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.operation.denormalized.DenormalizedOperation}.
         */
        public static fr.ifremer.adagio.core.dao.data.operation.denormalized.DenormalizedOperation newInstance()
        {
            final fr.ifremer.adagio.core.dao.data.operation.denormalized.DenormalizedOperation entity = new fr.ifremer.adagio.core.dao.data.operation.denormalized.DenormalizedOperationImpl();
			return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.operation.denormalized.DenormalizedOperation}, taking all required and/or
         * read-only properties as arguments.
         */
        public static fr.ifremer.adagio.core.dao.data.operation.denormalized.DenormalizedOperation newInstance(java.lang.Short rankOrder, java.lang.Boolean isLandingSampling, java.lang.Boolean isDiscardSampling, fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip fishingTrip)
        {
            final fr.ifremer.adagio.core.dao.data.operation.denormalized.DenormalizedOperation entity = newInstance();
            entity.setRankOrder(rankOrder);
            entity.setIsLandingSampling(isLandingSampling);
            entity.setIsDiscardSampling(isDiscardSampling);
            entity.setFishingTrip(fishingTrip);
            return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.operation.denormalized.DenormalizedOperation}, taking all possible properties
         * (except the identifier(s))as arguments.
         */
        public static fr.ifremer.adagio.core.dao.data.operation.denormalized.DenormalizedOperation newInstance(java.lang.Short rankOrder, java.lang.Boolean isLandingSampling, java.lang.Boolean isDiscardSampling, java.lang.Float gearMeshSize, java.lang.Float gearDepth, java.lang.Float mainWaterDepth, java.sql.Timestamp updateDate, fr.ifremer.adagio.core.dao.referential.location.Location subpolygonLocation, fr.ifremer.adagio.core.dao.referential.location.Location rectangleLocation, fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue selectiveDevice, fr.ifremer.adagio.core.dao.referential.gear.Gear gear, fr.ifremer.adagio.core.dao.referential.location.Location areaLocation, fr.ifremer.adagio.core.dao.referential.metier.Metier metier, fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip fishingTrip)
        {
            final fr.ifremer.adagio.core.dao.data.operation.denormalized.DenormalizedOperation entity = newInstance();
            entity.setRankOrder(rankOrder);
            entity.setIsLandingSampling(isLandingSampling);
            entity.setIsDiscardSampling(isDiscardSampling);
            entity.setGearMeshSize(gearMeshSize);
            entity.setGearDepth(gearDepth);
            entity.setMainWaterDepth(mainWaterDepth);
            entity.setUpdateDate(updateDate);
            entity.setSubpolygonLocation(subpolygonLocation);
            entity.setRectangleLocation(rectangleLocation);
            entity.setSelectiveDevice(selectiveDevice);
            entity.setGear(gear);
            entity.setAreaLocation(areaLocation);
            entity.setMetier(metier);
            entity.setFishingTrip(fishingTrip);
            return entity;
        }
    }
    
// DenormalizedOperation.java merge-point
}